#include <stdlib.h>
#include <conio.h>
#include <time.h>
#include <limits.h>


// Wieviele Scheiben?
#define MAX_SCHEIBEN 64

int main(int argc, char *argv[])
{
	int i, j=0;
	int a, b, c, atop, btop, ctop;
	int hanoi[3][MAX_SCHEIBEN]= {0};
	int usedScheiben = 26;
	int top[3]= {0};
	int start=0;	// erster, zu testender turm
	int steps=0;	//zhlt die bentigten Schritte
	clock_t t_start, t_finish;
	double  duration, dur_8, dur_16, dur_24, dur_32, dur_48, dur_56, dur_64;

	for (i=0; i<usedScheiben; i++)	hanoi[0][i]=usedScheiben-i;
	top[0]= usedScheiben-1; //voller Turm
	top[1]= -1;				//leer
	top[2]= -1;

	t_start = clock();

	// Main Loop
	while( 1 )
	{
		// Ausgabe
		/*
		for(i=usedScheiben-1; i>=0; i--)
			printf("%s%s%s\n", scheibe[hanoi[0][i]], scheibe[hanoi[1][i]], scheibe[hanoi[2][i]] );
		printf("tops%10i%15i%15i\n", top[0], top[1], top[2]);
		printf("steps: %i      start: %i", steps, start);
		printf("\n\n\n\n\n\n\n\n\n\n\n");
		//pause
		brems=1; while(brems<400000) brems*=1.0000001;
		*/
		// Berechnung
		if(! (steps%1000000)) printf("steps: %i\n", steps);
		for(i=0; i<3; i++)
		{
			//start=0;
			a = (start+i)%3;	b = (start+i+1)%3; c = (start+i+2)%3;
			atop = top[a];
			btop = top[b]; // einer der beiden anderen Trme
			ctop = top[c]; // einer der beiden anderen Trme
			//printf("top a:%i    for: %i\n", top[a], i);
			if(top[a] > -1) //turm ist nicht leer?
			{
						// zielturm leer? oder groessere Scheibe?
				if( (btop == -1)  ||  (btop > -1) && (hanoi[a][atop] < hanoi[b][btop]) )
				{
					hanoi[b][btop+1] = hanoi[a][atop];
					hanoi[a][atop] = 0; //nur der Ordnung halber...
					top[a]--; // quellturm 1 niedriger
					top[b]++; // zielturm 1 hoeher
					start = c; //nchstes Mal c zuerst testen.
					steps++;
					break;	// ausgabe, dann von vorn...
				}
					// c leer ODER a kleiner c
				if( (ctop == -1)  ||  (ctop > -1) && (hanoi[a][atop] < hanoi[c][ctop]) )
				{
					hanoi[c][ctop+1] = hanoi[a][atop];
					hanoi[a][atop] = 0; //nur der Ordnung halber...
					top[a]--; // quellturm 1 niedriger
					top[c]++; // zielturm 1 hoeher
					start = b; //nchstes Mal b zuerst testen.
					steps++;
					break;	// ausgabe, dann von vorn...
				}


			} // if turm nicht leer
		} // for 3

		if( (top[1]==usedScheiben-1) || (top[2]==usedScheiben-1) )	break;

	} // while (MAIN loop)
	printf("Ende!\n");
	t_finish = clock();
	duration = (double)(t_finish - t_start) / CLOCKS_PER_SEC;
	printf("Scheiben: %i   steps: %i   Dauer: %lf Sekunden\n", usedScheiben, steps, duration);

	dur_8 = dur_16 = dur_24 = dur_32 = dur_48 = dur_56 = dur_64 = duration;
		for(i=usedScheiben; i>1; i--)
		{
			if(i>=8)   dur_8/=2;
			if(i>=16) dur_16/=2;
			if(i>=24) dur_24/=2;
			if(i>=32) dur_32/=2;
			if(i>=48) dur_48/=2;
			if(i>=56) dur_56/=2;
			if(i>=64) dur_64/=2;
		}
		for(i=usedScheiben; i<=MAX_SCHEIBEN; i++)
		{
			if(i<=8)   dur_8*=2;
			if(i<=16) dur_16*=2;
			if(i<=24) dur_24*=2;
			if(i<=32) dur_32*=2;
			if(i<=48) dur_48*=2;
			if(i<=56) dur_56*=2;
			if(i<=64) dur_64*=2;
		}
		printf("Dauer  8 Sch.: %18.3lfs - %18.3lfm %18.3lfh\n", dur_8,  dur_8/60,  dur_8/3600);
		printf("Dauer 16 Sch.: %18.3lfs - %18.3lfm %18.3lfh\n", dur_16, dur_16/60, dur_16/3600);
		printf("Dauer 24 Sch.: %18.3lfs - %18.3lfm %18.3lfh\n", dur_24, dur_24/60, dur_24/3600);
		printf("Dauer 32 Sch.: %18.3lfs - %18.3lfm %18.3lfh\n", dur_32, dur_32/60, dur_32/3600);
		printf("Dauer 48 Sch.: %18.3lfs - %18.3lfm %18.3lfh\n", dur_48, dur_48/60, dur_48/3600);
		printf("Dauer 56 Sch.: %18.3lfs - %18.3lfm %18.3lfh\n", dur_56, dur_56/60, dur_56/3600);
		printf("Dauer 64 Sch.: %18.3lfs - %18.3lfm %18.3lfh\n", dur_64, dur_64/60, dur_64/3600);
		printf("\n");
			// d 3600*24	y 3600*24*365,24	yk 3600*24*365,24*1000 
		printf("Dauer  8 Sch.: %18.3lfd - %18.3lfy %18.3lfyk\n", dur_8 /86400,  dur_8/31556736,  dur_8/31556736000);
		printf("Dauer 16 Sch.: %18.3lfd - %18.3lfy %18.3lfyk\n", dur_16/86400, dur_16/31556736, dur_16/31556736000);
		printf("Dauer 24 Sch.: %18.3lfd - %18.3lfy %18.3lfyk\n", dur_24/86400, dur_24/31556736, dur_24/31556736000);
		printf("Dauer 32 Sch.: %18.3lfd - %18.3lfy %18.3lfyk\n", dur_32/86400, dur_32/31556736, dur_32/31556736000);
		printf("Dauer 48 Sch.: %18.3lfd - %18.3lfy %18.3lfyk\n", dur_48/86400, dur_48/31556736, dur_48/31556736000);
		printf("Dauer 56 Sch.: %18.3lfd - %18.3lfy %18.3lfyk\n", dur_56/86400, dur_56/31556736, dur_56/31556736000);
		printf("Dauer 64 Sch.: %18.3lfd - %18.3lfy %18.3lfyk\n", dur_64/86400, dur_64/31556736, dur_64/31556736000);
	getch();


    return 0;
}