#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>

void sleep( clock_t wait );

// Wieviele Scheiben?
#define MAX_SCHEIBEN 10

int main(int argc, char *argv[])
{
	int i, j=0;
	int a, b, c, atop, btop, ctop;
	int hanoi[3][MAX_SCHEIBEN]= {0};
	int usedScheiben = 8;
	int top[3]= {0};
	int start=0;	// erster, zu testender turm
	int steps=0;	//zhlt die bentigten Schritte
	char scheibe[MAX_SCHEIBEN+1][29]=
		{"                       ", "          [_]          ", "         [___]         ", "        [_____]        ",
		 "       [_______]       ", "      [_________]      ", "     [___________]     ", "    [_____________]    ",
		 "   [_______________]   ", "  [_________________]  ", " [___________________] " };

	for (i=0; i<usedScheiben; i++)	hanoi[0][i]=usedScheiben-i;
	top[0]= usedScheiben-1; //voller Turm
	top[1]= -1;				//leer
	top[2]= -1;

	// Main Loop
	while( 1 )
	{
		// Ausgabe
		for(i=usedScheiben-1; i>=0; i--)
			printf("%s%s%s\n", scheibe[hanoi[0][i]], scheibe[hanoi[1][i]], scheibe[hanoi[2][i]] );
		printf("tops%10i%15i%15i\n", top[0], top[1], top[2]);
		printf("steps: %i      start: %i", steps, start);
		printf("\n\n\n\n\n\n\n\n\n\n\n");
		//pause 500ms
		sleep(500);

		// Berechnung
		for(i=0; i<3; i++)
		{
			//start=0;
			a = (start+i)%3;	b = (start+i+1)%3; c = (start+i+2)%3;
			atop = top[a];
			btop = top[b]; // einer der beiden anderen Trme
			ctop = top[c]; // einer der beiden anderen Trme
			//printf("top a:%i    for: %i\n", top[a], i);
			if(top[a] > -1) //turm ist nicht leer?
			{
						// zielturm leer? oder groessere Scheibe?
				if( (btop == -1)  ||  (btop > -1) && (hanoi[a][atop] < hanoi[b][btop]) )
				{
					hanoi[b][btop+1] = hanoi[a][atop];
					hanoi[a][atop] = 0; //nur der Ordnung halber...
					top[a]--; // quellturm 1 niedriger
					top[b]++; // zielturm 1 hoeher
					start = c; //nchstes Mal c zuerst testen.
					steps++;
					break;	// ausgabe, dann von vorn...
				}
					// c leer ODER a kleiner c
				if( (ctop == -1)  ||  (ctop > -1) && (hanoi[a][atop] < hanoi[c][ctop]) )
				{
					hanoi[c][ctop+1] = hanoi[a][atop];
					hanoi[a][atop] = 0; //nur der Ordnung halber...
					top[a]--; // quellturm 1 niedriger
					top[c]++; // zielturm 1 hoeher
					start = b; //nchstes Mal b zuerst testen.
					steps++;
					break;	// ausgabe, dann von vorn...
				}


			} // if turm nicht leer
		} // for 3

	} // while (MAIN loop)
    return 0;
}

/* Pauses for a specified number of milliseconds. */
void sleep( clock_t wait )
{
   clock_t goal;
   goal = wait + clock();
   while( goal > clock() )
      ;
}
